RequireSystemScript("time.js");
RequireScript("neo_surface.js");
const SW = GetScreenWidth();
const SH = GetScreenHeight();
const INF = Number.POSITIVE_INFINITY;
const PI = Math.PI;
var SIN = Math.sin, COS = Math.cos;
var ROOT = Math.sqrt, POW = Math.pow;

Array.prototype.find = function(v) {
 for (var i=0; i<this.length; i++) {
  if (this[i]==v) return i;
  }
 return -1;
 }
Array.prototype.isEmpty = function() {
 for (var i=0; i<this.length; i++) {
  if (this[i]) return false;
  }
 return true;
 }

function ClearKeyQueue() {
 while (AreKeysLeft()) GetKey();
 }

function IsWhitespace(ch) {
 switch (ch) {
  case '\n': case '\r': case ' ': case '\b': return true;
  }
 return false;
 }

function IsAlpha(str) {
 var ltr = "abcdefghijklmnopqrstuvwxyz";
 str = str.toLowerCase();
 for (var i=0; i<str.length; i++)
  if (ltr.indexOf(str.charAt(i))<0) return false;
 return true;
 }

function IsChar(ch) {
 if (ch.length==1) {
  return (typeof ch=="string"||typeof ch=="char"||IsWhitespace(ch));
  }
 return false;
 }

function IsString(str) {
 return (typeof str=="string"||typeof str=="char");
 }

function IsInt(num) {
 return (num!=undefined&&num!=NaN&&num==parseInt(num));
 }

function IsArray(arr) {
 return (typeof(arr)=="array");
 }

function IsSound(snd) {
 return (typeof(snd)==typeof(LoadSound("00_drop.wav",false)));
 }
function IsNumber(n) {
 return (typeof(n)=="number"||typeof(n)=="integer");
 }
function IsFloat(n) {
 return (n==parseFloat(n));
 }

function IsImage(n) {
 return (typeof(n)==typeof(GetSystemArrow()));
 }

function IsFont(n) {
 return (typeof(n)==typeof(GetSystemFont()));
 }

function IsColor(n) {
 return (typeof(n)==typeof(CreateColor(0,0,0)));
 }

function IsWindowStyle(n) {
 return (typeof(n)==typeof(GetSystemWindowStyle()));
 }

function IsSpriteset(n) {
 return (typeof(n)==typeof(LoadSpriteset("c_pengu.rss")));
 }

function IsFunction(func) {
 return (typeof(func)==typeof(function(){}));
 }

function IsDefined(v) {
 return (v!=undefined&&v!=null);
 }

function function_exists(func) {
 // must put the name of the function WITHOUT any "s or 's
 // ie function_exists(Abort)
 return (IsDefined(func)&&IsFunction(func));
 }

function padL(str,amt,ch) {
 str = str.toString();
 if (!ch) ch = " ";
 for (var i=0; i<amt; i++) {
  str = ch+""+str;
  }
 return str;
 }
function padR(str,amt,ch) {
 str = str.toString();
 if (!ch) ch = " ";
 for (var i=0; i<amt; i++) {
  str += ""+ch;
  }
 return str;
 }
function pad(str,amt,ch) {
 str = str.toString();
 if (!ch) ch = " ";
 for (var i=0; i<amt; i++) {
  str = ch+""+str+""+ch;
  }
 return str;
 }
function padIfL(str,len,ch) {
 str = str.toString();
 if (!ch) ch = " ";
 if (str.length<len) for (var i=0; i<len-str.length; i++) {
  str = ch+""+str;
  }
 return str;
 }
function padIfR(str,len,ch) {
 str = str.toString();
 if (!ch) ch = " ";
 if (str.length<len) for (var i=0; i<len-str.length; i++) {
  str += ""+ch;
  }
 return str;
 }

function keyStr(key,shift) { // GetKeyString() w/conv
 var ret = '';
 switch (key) {
  case KEY_ESCAPE: ret = "ESC"; break;
  case KEY_F1: ret = "F1"; break;
  case KEY_F2: ret = "F2"; break;
  case KEY_F3: ret = "F3"; break;
  case KEY_F4: ret = "F4"; break;
  case KEY_F5: ret = "F5"; break;
  case KEY_F6: ret = "F6"; break;
  case KEY_F7: ret = "F7"; break;
  case KEY_F8: ret = "F8"; break;
  case KEY_F9: ret = "F9"; break;
  case KEY_F10: ret = "F10"; break;
  case KEY_F11: ret = "F11"; break;
  case KEY_F12: ret = "F12"; break;
  case KEY_SHIFT: ret = "SHIFT"; break;
  case KEY_BACKSPACE: ret = "BKSP"; break;
  case KEY_TAB: ret = "TAB"; break;
  case KEY_CTRL: ret = "CTRL"; break;
  case KEY_ALT: ret = "ALT"; break;
  case KEY_SPACE: ret = "SPACE"; break;
  case KEY_ENTER: ret = "ENTER"; break;
  case KEY_INSERT: ret = "INS"; break;
  case KEY_DELETE: ret = "DEL"; break;
  case KEY_HOME: ret = "HOME"; break;
  case KEY_END: ret = "END"; break;
  case KEY_PAGEUP: ret = "PGUP"; break;
  case KEY_PAGEDOWN: ret = "PGDN"; break;
  case KEY_UP: ret = ".U"; break;
  case KEY_RIGHT: ret = ".R"; break;
  case KEY_DOWN: ret = ".D"; break;
  case KEY_LEFT: ret = ".L"; break;
  default: ret = GetKeyString(key,shift);
  }
 return ret;
 }


//MATH
function ptSlope(x1,y1, x2,y2) {
 var o = new Object();
 var m = (y1-y2)/(x1-x2);
 var b = y1-m*x1;
 o.m = m; o.b = b;
 return o;
 }

function fix(num,min,max) {
 return parseInt(limit(num,min,max));
 }
function limit(num,min,max) {
 var temp = min;
 if (min>max) {min = max; max = temp;}
 if (num>max) num = max;
 else if (num<min) num = min;
 return num;
 }
function rnd(num) {
 var r = Math.random();
 r = r.toString().slice(2);
 return r%num;
 }

function d2r(d) {
 return PI*d/180;
 }
function r2d(r) {
 return 180*r/PI;
 }

//IMAGE
function ScrToImage() {
 return GrabImage(0,0,SW,SH);
 }
function ScrToSurface() {
 return GrabSurface(0,0,SW,SH);
 }
function ScrTo2dArray(w,h) {
 var SW = GetScreenWidth(), SH = GetScreenHeight();
 var s = ScrToSurface();
 var ret = new Array();
 var c = SW/w, r = SH/h;
 for (var i=0; i<r; i++) ret.push(new Array());
 for (i=0; i<ret.length; i++) {
  for (var j=0; j<c; j++) ret[i].push(s.cloneSection(j*w,i*h,w,h).createImage());
  }
 return ret;
 }
function ScrToWidthArray(h) {
 var SW = GetScreenWidth(), SH = GetScreenHeight();
 var s = ScrToSurface();
 var ret = new Array(), r = SH/h;
 for (var i=0; i<r; i++) ret.push(s.cloneSection(0,i*h,SW,h).createImage());
 return ret;
 }
function ScrToHeightArray(w) {
 var SW = GetScreenWidth(), SH = GetScreenHeight();
 var s = ScrToSurface();
 var ret = new Array(), c = SW/w;
 for (var i=0; i<c; i++) ret.push(s.cloneSection(i*w,0,w,SH).createImage());
 return ret;
 }

function MapToSurface() {
 if (!IsMapEngineRunning()) return CreateSurface(0,0, CreateColor(0,0,0));
 var tile_surfaces = [];
 for (var i=0; i<GetNumTiles(); ++i) {
  var tile_surface = GetTileImage(i).createSurface();
  //tile_surface.rescale(1, 1);
  tile_surfaces.push(tile_surface);
  }
 var tile_width = GetTileWidth();
 var tile_height = GetTileHeight();
 var map_width = GetMapWidth();
 var map_height = GetMapHeight();
 var map_surface = new Surface(map_width*tile_width,map_height*tile_height, CreateColor(0,0,0));
 for (var layer=0; layer<GetNumLayers(); ++layer) {
  var offset_x = MapToScreenX(layer, 0);
  var offset_y = MapToScreenY(layer, 0);
  var layer_width  = GetLayerWidth(layer);
  var layer_height = GetLayerHeight(layer);
  for (var y=0; y<layer_height; ++y) {
   for (var x=0; x<layer_width; ++x) {
    var t = GetTile(x,y,layer);
    map_surface.blendSurface(tile_surfaces[t], x*tile_width, y*tile_height);
    }
   }
  }
 return map_surface;
 }
function MapToImage() {
 return MapToSurface().createImage();
 }

function pixelate(img,inten) {
 var s = img.createSurface();
 var w = img.width, h = img.height;
 if (inten>1) {
  s.rescale(w/inten,h/inten);
  s.rescale(w,h);
  }
 return s.createImage();
 }

function GetColorImage(w,h,col) {
 return CreateSurface(w,h,col).createImage();
 }

function GradientLineCenter(x1,y1,x2,y2,c1,c2) {
 var xmid = (x2-x1)/2, ymid = (y2-y1)/2;
 GradientLine(x1,y1,x1+xmid,y1+ymid, c1,c2);
 GradientLine(x1+xmid,y1+ymid,x2,y2, c2,c1);
 }

function GradientRectangleCenterH(x,y,w,h,c1,c2,c3,c4) {
 var xmid = w/2;
 GradientRectangle(x,y,xmid,h,c1,c2,c3,c4);
 GradientRectangle(x+xmid,y,xmid,h,c2,c1,c4,c3);
 }

function GradientRectangleCenterV(x,y,w,h,c1,c2,c3,c4) {
 var ymid = h/2;
 GradientRectangle(x,y,w,ymid,c1,c2,c3,c4);
 GradientRectangle(x,y+ymid,w,ymid,c4,c3,c2,c1);
 }

function GradientRectangleCross(x,y,w,h,c1,c2,c3,c4) {
 var xmid = w/2, ymid = h/2;
 GradientRectangle(x,y,xmid,ymid,c1,c2,c3,c4);
 GradientRectangle(x+xmid,y,xmid,ymid,c2,c1,c4,c3);
 GradientRectangle(x+xmid,y+ymid,xmid,ymid,c3,c4,c1,c2);
 GradientRectangle(x,y+ymid,xmid,ymid,c4,c3,c2,c1);
 }

function GetMapWidth() {
 var w = 0;
 if (IsMapEngineRunning()) for (var i=0; i<GetNumLayers(); i++) {
  var l = GetLayerWidth(i);
  if (l>w) w = l;
  }
 return w;
 }

function GetMapHeight() {
 var h = 0;
 if (IsMapEngineRunning()) for (var i=0; i<GetNumLayers(); i++) {
  var l = GetLayerHeight(i);
  if (l>h) h = l;
  }
 return h;
 }

function file_exists(file,dir) {
 if (!dir) dir = "save";
 var a = GetFileList(dir);
 for (var i=0; i<a.length; i++) {
  if (a[i]==file) return true;
  }
 return false;
 }