RequireScript("a_req.js");

var g = new Object();

g.cols = new Object();
g.cols.w = CreateColor(255,255,255);
g.cols.k = CreateColor(0,0,0);
g.cols.r = CreateColor(255,0,0);
g.cols.g = CreateColor(0,255,0);
g.cols.b = CreateColor(0,0,255);
g.cols.c = CreateColor(0,255,255);
g.cols.m = CreateColor(255,0,255);
g.cols.y = CreateColor(255,255,0);
g.cols.o = CreateColor(255,160,0);
g.cols.grey = CreateColor(128,128,128);
g.cols.silv = CreateColor(192,192,192);
g.cols.ruby = CreateColor(224,32,0);
g.cols.jade = CreateColor(32,224,0);
g.cols.sapp = CreateColor(0,32,224);
g.cols.crys = CreateColor(0,128,224);
g.cols.topaz = CreateColor(224,224,0);

g.f = new Object();
g.f.main = LoadFont("msmincho.rfn");
g.f.sq = LoadFont("square1.rfn");

g.rgb = LoadImage("i_arrows.png");

g.points = [];

g.aX = PI/4;
g.aY = PI/4;
g.camX = 100;
g.camY = 100;
g.unit = 32;
g.zoom = 1;
g.tilt = 1;
g.projX = new pObj(g.unit*g.zoom*COS(g.aX),-g.unit*g.zoom*SIN(g.aX)*g.tilt);
g.projY = new pObj(g.unit*g.zoom*SIN(g.aY),g.unit*g.zoom*COS(g.aY)*g.tilt);
g.projZ = new pObj(g.unit*g.zoom,-g.unit*g.zoom);

g.vZWin = 2;
g.vPCenter = new pObj(SW/2,SH/2,0);

g.vLen = 1;
g.vP = [];
g.vP.push(new pObj(0,0));
g.vP.push(new pObj(g.vLen,0));
g.vP.push(new pObj(g.vLen,g.vLen));
g.vP.push(new pObj(0,g.vLen));

g.vP.push(new pObj(0,0));
g.vP.push(new pObj(g.vLen,0));
g.vP.push(new pObj(g.vLen,0,g.vLen));
g.vP.push(new pObj(0,0,g.vLen));

g.vP.push(new pObj(0,0));
g.vP.push(new pObj(0,0,g.vLen));
g.vP.push(new pObj(0,g.vLen,g.vLen));
g.vP.push(new pObj(0,g.vLen));

RequireScript("b_cube.js");
RequireScript("e_map.js");

g.drawPts = function() {
 var l = g.points.length
 for (var i=0; i<l-1; i++) {
  var p1 = g.points[i], p2 = g.points[i+1];
  Line(p1.x,p1.y,p2.x,p2.y, g.cols.w);
  }
 Line(g.points[l-1].x,g.points[l-1].y,g.points[0].x,g.points[0].y, g.cols.w);
 }
g.drawPtsNearest = function() {
 var pArr = [];
 var img = ScrToImage();
 var l = g.points.length;
 var i = 0, cur = 0;
 var d = 250;
 while (cur<g.points.length-1) {
  FlipScreen();
  Delay(d);
  img.blit(0,0);
  var p1 = g.points[i];
  var nArr = sortByNearest(p1);
  var cI = 0;
  var n = nArr[cI];
  while (pArr.find(n)!=-1&&cI<g.points.length) {
   n = nArr[++cI];
   }
  pArr.push(n);
  var p2 = g.points[n];
  Line(p1.x,p1.y,p2.x,p2.y, g.cols.w);
  img = ScrToImage();
  i = n;
  cur++;
  }
 img.blit(0,0);
 Line(g.points[0].x,g.points[0].y,g.points[i].x,g.points[i].y, g.cols.w);
 img = ScrToImage();
 Delay(d);
 FlipScreen();
 Delay(d);
 img.blit(0,0);
 }

g.rndPts = function(num) {
 g.points = [];
 do {
  var x = rnd(SW), y = rnd(SH);
  g.points.push(new pObj(x,y));
  } while (num--);
 }

function particle(r,col,rad,p) {
 if (!p||p<2) p = rnd(20);
 var a = d2r(360/p);
 if (!rad) rad = 0;
 var tot = 0;
 var clr = CreateColor(0,0,0,0);
 var s = CreateSurface(r*2+1,r*2+1,clr);
 s.setBlendMode(REPLACE);
 var root = Math.sqrt, pow = Math.pow, abs = Math.abs;
 var sw = s.width, sh = s.height;
 do {
  var fx = r, fy = r;
  var dx = Math.cos(tot+rad), dy = Math.sin(tot+rad);
  while (0<fx&&fx<sw&&0<fy&&fy<sh) {
   var r2 = pow(fx-r,2)+pow(fy-r,2);
   var i = parseInt(256*pow(1-r2/(r*r),6));
   if (r2>r*r) break;
   s.setPixel(fx,fy,CreateColor(col.red,col.green,col.blue,i));
   fy += dy;
   fx += dx;
   }
  tot += a;
  } while (tot<2*PI);
 return s;
 }
function flare(r,col,type) {
 if (!type) type = 0;
 var smooth = function(a,b,z) {
  if (z<a) return 0;
  if (z>=b) return 1;
  z = (z-a)/(b-a);
  return z*z*(3-2*z);
  }
 var clr = CreateColor(0,0,0,0);
 var s = CreateSurface(r*2+1,r*2+1,clr);
 s.setBlendMode(REPLACE);
 var c = [];
 //for (var i=0; i<256; i++) c[i] = CreateColor(col.red,col.green,col.blue,i);
 var root = Math.sqrt, pow = Math.pow, abs = Math.abs;
 for (var x=0; x<s.width; x++) {
  for (var y=0; y<s.height; y++) {
   var d = root(pow(r-x,2)+pow(r-y,2));
   var i;
   switch (type) {
    case 0: i = pow(1-d/r,2); break;
    case 1: i = pow(d/r,6); break;
    case 2: i = d/r; break;
    case 3: var q = 1-abs(d/r-.9)/.1; if (q<0) q = 0; i = pow(q,2); break;
    }
   //if (d>r)
   i *= 1-smooth(1-.01,1+.01, d/r);
   var alpha = parseInt(256*i);
   s.setPixel(x,y,CreateColor(col.red,col.green,col.blue,alpha));
   }
  }
 return s;
 }

function pObj(x,y,z) {
 if (!this instanceof pObj) return new pObj(x,y,z);
 this.x = (IsFloat(x))?x:0;
 this.y = (IsFloat(y))?y:0;
 this.z = (IsFloat(z))?z:0;
 }
function sortByNearest(p) {
 var arr = [];
 var root = Math.sqrt, pow = Math.pow;
 var len = g.points.length;
 for (var i=0; i<len; i++) {
  var p1 = g.points[i];
  if (p.x==p1.x&&p.y==p1.y) arr.push(0);
  else
   arr.push(root(pow(p.x-p1.x,2)+pow(p.y-p1.y,2)));
  }
 var ret = [], dis = [];
 for (var i=0; i<len; i++) if (arr[i]==0) dis.push(i);
 var dl = dis.length, j = -1;
 while (ret.length<len-(dl+1)) {
  var min = INF;
  for (var i=0; i<len; i++) {
   if (arr[i]==0||dis.find(i)!=-1) continue;
   if (arr[i]<min) {
    min = arr[i];
    j = i;
    //Abort(j);
    }
   //else Abort("can't lower "+min);
   }
  ret.push(j);
  dis.push(j);
  }
 for (var i=0; i<dl; i++)
  ret.push(dis[i]);
 return ret;
 }
function nearest(p) {
 var min = INF;
 var ret = -1;
 var root = Math.sqrt, pow = Math.pow;
 for (var i=0; i<g.points.length; i++) {
  var p1 = g.points[i];
  if (p.x==p1.x&&p.y==p1.y) continue;
  var d = root(pow(p.x-p1.x,2)+pow(p.y-p1.y,2));
  if (d<min) {
   min = d;
   ret = i;
   }
  }
 return ret;
 }