RequireScript("a_req.js");
function slope(l,x,y,z,face,a) {
 if (!this instanceof slope) return new slope(l,x,y,z,face);
 this.w = (l>0)?l:1;
 this.x = (IsFloat(x))?x:0;
 this.y = (IsFloat(y))?y:0;
 this.z = (IsFloat(z))?z:0;
 this.face = (face)?face:GetColorImage(this.w,this.w,g.cols.w);
 this.a = (a>0)?a:0;
 }
slope.prototype.blit = function(x,y,col,lines) {
 var w = this.w;
 lines = (lines)?lines:false;
 var l = w*g.unit*g.zoom;
 var c1 = BlendColorsWeighted(col,g.cols.k,2,1);
 var c2 = BlendColorsWeighted(col,g.cols.k,3,1);
 var xoff = (this.x+this.y)*(l);
 var yoff = (this.y-this.x)*(l/2)-this.z*l;
 x += xoff; y += yoff;
 //this.face.transformBlitMask(
	//x,y+l, x+l,y+l-l/2,
	//x+2*l,y+l, x+l,y+l+l/2,
	//col);
 var s = this.a%4;
 var x1 = x, x2 = x+l, x3 = x+2*l, x4 = x+l;
 var y1 = y, y2 = y-l/2, y3 = y+l, y4 = y+l+l/2;
 var tx1 = x, tx2 = x+l, tx3 = x;
 var ty1 = y, ty2 = y+l+l/2, ty3 = y+l;
 var cface = col, ctri = c1;
 switch (s) {
  case 1:
   x1 = x+l; x2 = x+2*l; x3 = x+l; x4 = x;
   y1 = y-l/2; y2 = y; y3 = y+l+l/2; y4 = y+l;
   tx1 = x+2*l; tx2 = x+2*l; tx3 = x+l;
   ty1 = y; ty2 = y+l; ty3 = y+l+l/2;
   cface = c1; ctri = c2; break;
  case 2:
   x1 = x+l; x2 = x+2*l; x3 = x+2*l; x4 = x+l;
   y1 = y+l/2; y2 = y; y3 = y+l; y4 = y+l+l/2;
   tx1 = x+l; tx2 = x+l; tx3 = x;
   ty1 = y+l/2; ty2 = y+l+l/2; ty3 = y+l;
   cface = c2; break;
  case 3:
   x1 = x; x2 = x+l; x3 = x+l; x4 = x;
   y1 = y; y2 = y+l/2; y3 = y+l+l/2; y4 = y+l;
   tx1 = x+l; tx2 = x+2*l; tx3 = x+l;
   ty1 = y+l/2; ty2 = y+l; ty3 = y+l+l/2;
   cface = c1; ctri = c2; break;
  }
 this.face.transformBlitMask(
	tx1,ty1, tx2,ty2,
	tx3,ty3, tx3,ty3,
	ctri);
 this.face.transformBlitMask(
	x1,y1, x2,y2,
	x3,y3, x4,y4,
	cface);
 if (lines) {
  Line(x,y, x+l,y+l/2,col);
  Line(x+l,y+l/2, x+l,y+l+l/2,col);
  Line(x+l,y+l+l/2, x,y+l,col);
  Line(x,y+l, x,y,col);
  Line(x+l,y+l/2, x+2*l,y,col);
  Line(x+2*l,y,	x+2*l,y+l,col);
  Line(x+2*l,y+l, x+l,y+l+l/2,col);
  Line(x,y, x+l,y-l/2,col);
  Line(x+l,y-l/2, x+2*l,y,col);
  }
 }

function tri(l,x,y,z,face,a) {
 if (!this instanceof tri) return new tri(l,x,y,z,face);
 this.w = (l>0)?l:1;
 this.x = (IsFloat(x))?x:0;
 this.y = (IsFloat(y))?y:0;
 this.z = (IsFloat(z))?z:0;
 this.face = (face)?face:GetColorImage(this.w,this.w,g.cols.w);
 this.a = (a>0)?a:0;
 }
tri.prototype.blit = function(x,y,col,lines) {
 var w = this.w;
 lines = (lines)?lines:false;
 var l = w*g.unit*g.zoom;
 var c1 = BlendColorsWeighted(col,g.cols.k,1,3);
 var c2 = BlendColorsWeighted(col,g.cols.k,1,1);
 var xoff = (this.x+this.y)*(l);
 var yoff = (this.y-this.x)*(l/2)-this.z*l;
 x += xoff; y += yoff;
 //this.face.transformBlitMask(
	//x,y+l, x+l,y+l-l/2,
	//x+2*l,y+l, x+l,y+l+l/2,
	//col);
 var s = this.a%4;
 var x1 = x, x2 = x+2*l, x3 = x+l;
 var y1 = y, y2 = y+l, y3 = y+l+l/2;
 var tx1 = x, tx2 = x+l, tx3 = x;
 var ty1 = y, ty2 = y+l+l/2, ty3 = y+l;
 var cface = col, ctri = c1;
 switch (s) {
  case 1:
   x1 = x+l; x2 = x+l; x3 = x;
   y1 = y-l/2; y2 = y+l+l/2; y3 = y+l;
   tx1 = x+l; tx2 = x+2*l; tx3 = x+l;
   ty1 = y-l/2; ty2 = y+l; ty3 = y+l+l/2;
   cface = c1; ctri = c2; break;
  case 2:
   x1 = x+2*l; x2 = x+l; x3 = x;
   y1 = y; y2 = y+l+l/2; y3 = y+l;
   tx1 = x+2*l; tx2 = x+2*l; tx3 = x+l;
   ty1 = y; ty2 = y+l; ty3 = y+l+l/2;
   cface = c1; ctri = c2; break;
  case 3:
   x1 = x+l; x2 = x+l; x3 = x;
   y1 = y+l/2; y2 = y+l+l/2; y3 = y+l;
   tx1 = x+l; tx2 = x+2*l; tx3 = x+l;
   ty1 = y+l/2; ty2 = y+l; ty3 = y+l+l/2;
   cface = c1; ctri = c2; break;
  }
 this.face.transformBlitMask(
	tx1,ty1, tx2,ty2,
	tx3,ty3, tx3,ty3,
	ctri);
 this.face.transformBlitMask(
	x1,y1, x2,y2,
	x3,y3, x3,y3,
	cface);
 if (lines) {
  Line(x,y, x+l,y+l/2,col);
  Line(x+l,y+l/2, x+l,y+l+l/2,col);
  Line(x+l,y+l+l/2, x,y+l,col);
  Line(x,y+l, x,y,col);
  Line(x+l,y+l/2, x+2*l,y,col);
  Line(x+2*l,y,	x+2*l,y+l,col);
  Line(x+2*l,y+l, x+l,y+l+l/2,col);
  Line(x,y, x+l,y-l/2,col);
  Line(x+l,y-l/2, x+2*l,y,col);
  }
 }

function cube(l,x,y,z,face) {
 if (!this instanceof cube) return new cube(l,x,y,z,face);
 this.w = (l>0)?l:1;
 this.x = (IsFloat(x))?x:0;
 this.y = (IsFloat(y))?y:0;
 this.z = (IsFloat(z))?z:0;
 this.face = (face)?face:GetColorImage(this.w,this.w,g.cols.w);
 }
cube.prototype.blit = function(x,y,col,lines) {
 var w = this.w;
 lines = (lines)?lines:false;
 var l = w*g.unit*g.zoom;
 var c1 = BlendColorsWeighted(col,g.cols.k,1,3);
 var c2 = BlendColorsWeighted(col,g.cols.k,1,1);
 var xoff = (this.x+this.y)*(l);
 var yoff = (this.y-this.x)*(l/2)-this.z*l;
 x += xoff; y += yoff;
 this.face.transformBlitMask(
	x,y, x+l,y+l/2,
	x+l,y+l+l/2, x,y+l,
	c1);
 this.face.transformBlitMask(
	x+l,y+l/2, x+2*l,y,
	x+2*l,y+l, x+l,y+l+l/2,
	c2);
 this.face.transformBlitMask(
	x,y, x+l,y-l/2,
	x+2*l,y, x+l,y+l/2,
	col);
 if (lines) {
  Line(x,y, x+l,y+l/2,col);
  Line(x+l,y+l/2, x+l,y+l+l/2,col);
  Line(x+l,y+l+l/2, x,y+l,col);
  Line(x,y+l, x,y,col);
  Line(x+l,y+l/2, x+2*l,y,col);
  Line(x+2*l,y,	x+2*l,y+l,col);
  Line(x+2*l,y+l, x+l,y+l+l/2,col);
  Line(x,y, x+l,y-l/2,col);
  Line(x+l,y-l/2, x+2*l,y,col);
  }
 }

function map2d(fn) {
 if (!this instanceof map2d) return new map2d(fn);
 var f = OpenFile("../dat/"+fn)||Abort("map2d: error opening "+fn);
 this.filename = fn;
 var layers = f.read("LAYERS",1);
 var dim = f.read("MAP","1,1").split(",");
 this.width = dim[0];
 this.height = dim[1];
 this.layers = [];
 for (var i=0; i<layers; i++) {
  for (var x=0; x<this.width; x++) {
   for (var y=0; y<this.height; y++) {
    var t = f.read("LAYER_"+i+"["+x+","+y+"]","");
    if (t) {
     if (!this.layers[i]) this.layers[i] = [];
     if (!this.layers[i][x]) this.layers[i][x] = [];
     this.layers[i][x][y] = t;
     }
    }
   }
  }
 }
map2d.prototype.blit = function(cx,cy) {
 var tiles = [], cols = [];
 for (var i=0; i<this.layers.length; i++) {
  for (var y=0; y<this.height; y++) {
   for (var x=this.width-1; x>=0; x--) {
    if (this.layers[i])
     if (this.layers[i][x])
      if (this.layers[i][x][y]) {
       var t = this.layers[i][x][y].split(",");
       var o;
       switch (t[3].charAt(0)) {
        case "s": o = new slope(1,x,y,i,null,t[3].charAt(1)); break;
        case "t": o = new tri(1,x,y,i,null,t[3].charAt(1)); break;
        default: o = new cube(1,x,y,i,null); break;
        }
       tiles.push(o);
       cols.push(this.layers[i][x][y]);
       }
    }
   }
  }
 for (var i=0; i<tiles.length; i++) {
  var c = tiles[i];
  var col = cols[i].split(",");
  c.blit(cx,cy,CreateColor(col[0],col[1],col[2]));
  }
 }
map2d.prototype.list = function() {
 var ret = "**"+this.filename+"\n";
 for (var i=0; i<this.layers.length; i++) {
  for (var x=0; x<this.width; x++) {
   for (var y=0; y<this.height; y++) {
    if (this.layers[i][x])
     if (this.layers[i][x][y])
      ret += "["+i+":"+x+","+y+"]:"+this.layers[i][x][y]+"\n";
    }
   }
  }
 ret += "**END";
 return ret;
 }
map2d.prototype.save = function(fn) {
 if (!this.filename) this.filename = fn;
 var f = OpenFile("../dat/"+this.filename)||Abort("map2d: error saving to "+this.filename);
 f.write("MAP",this.width+","+this.height);
 f.write("LAYERS",this.layers.length);
 for (var i=0; i<this.layers.length; i++) {
  for (var x=0; x<this.width; x++) {
   for (var y=0; y<this.height; y++) {
    if (this.layers[i])
     if (this.layers[i][x])
      if (this.layers[i][x][y])
       f.write("LAYER_"+i+"["+x+","+y+"]",this.layers[i][x][y]);
    }
   }
  }
 f.flush();
 }