function Surface(w,h,col) {
 if (!this instanceof Surface) return new Surface(w,h,col);
 this.surface = CreateSurface(w,h,col);
 this.width = this.surface.width;
 this.height = this.surface.height;
 this.reset = function() {
  this.width = this.surface.width;
  this.height = this.surface.height;
  }
 }
Surface.prototype.createFromImage = function(img) {
 this.surface = img.createSurface();
 this.reset();
 }
Surface.prototype.createFromSurface = function(s) {
 this.surface = s;
 this.reset();
 }
Surface.prototype.loadFromImage = function(f) {
 this.surface = LoadSurface(f);
 this.reset();
 }
Surface.prototype.grab = function(x,y,w,h) {
 this.surface = GrabSurface(x,y,w,h);
 this.reset();
 }
Surface.prototype.applyLookup = function(x,y,w,h, lRed,lGrn,lBlu,lAlp) {
 this.surface.applyLookup(x,y,w,h,lRed,lGrn,lBlu,lAlp);
 }
/*  surface_object.applyLookup(x, y, w, h, red_lookup, green_lookup, blue_lookup, alpha_lookup);
    - Apply a lookup table transformation to the pixels contained in x, y, w, h
    The lookup parameters are arrays of 256 elements containg the new pixel values.
    e.g. var invert_lookup = [255, 254, 253, 252, 251, ..., 4, 3, 2, 1, 0];
  */
Surface.prototype.applyColorFX = function(x,y,w,h,cm) {
 this.surface.applyColorFX(x,y,w,h,cm);
 }
Surface.prototype.applyColorFX4 = function(x,y,w,h, cm_ul,cm_ur,cm_ll,cm_lr) {
 this.surface.applyColorFX4(x,y,w,h, cm_ul,cm_ur,cm_ll,cm_lr);
 }
Surface.prototype.blit = function(x,y) {
 this.surface.blit(x,y);
 }
Surface.prototype.blitSurface = function(s,x,y) {
 this.surface.blitSurface(s,x,y);
 }
Surface.prototype.blitImage = function(i,x,y) {
 this.blitSurface(i.createSurface(),x,y);
 }
Surface.prototype.blendSurface = function(s,x,y) {
 for (var sx=0; sx<s.width; sx++) {
  for (var sy=0; sy<s.height; sy++) {
   var p = s.getPixel(sx,sy);
   if (p.alpha<255) this.setBlendMode(BLEND);
   else this.setBlendMode(REPLACE);
   if (p.alpha>0) this.setPixel(x+sx,y+sy,p);
   }
  }
 }
Surface.prototype.createImage = function() {
 return this.surface.createImage();
 }
Surface.prototype.setBlendMode = function(m) {
 this.surface.setBlendMode(m);
 }
Surface.prototype.getPixel = function(x,y) {
 return this.surface.getPixel(x,y);
 }
Surface.prototype.setPixel = function(x,y,c) {
 this.surface.setPixel(x,y,c);
 }
Surface.prototype.setAlpha = function(a) {
 this.surface.setAlpha(a);
 }
Surface.prototype.replaceColor = function(cOld,cNew) {
 this.surface.replaceColor(cOld,cNew);
 }
Surface.prototype.line = function(x1,y1,x2,y2,c) {
 this.surface.line(x1,y1,x2,y2,c);
 }
Surface.prototype.rectangle = function(x,y,w,h,c) {
 this.surface.rectangle(x,y,w,h,c);
 }
Surface.prototype.triangle = function(x1,y1,x2,y2,x3,y3,c) {
 this.surface.triangle(x1,y1,x2,y2,x3,y3,c);
 }
Surface.prototype.rotate = function(r,size) {
 this.surface.rotate(r,size);
 }
Surface.prototype.resize = function(w,h) {
 this.surface.resize(w,h);
 }
Surface.prototype.rescale = function(w,h) {
 this.surface.rescale(w,h);
 }
Surface.prototype.flipHorizontally = function() {
 this.surface.flipHorizontally();
 }
Surface.prototype.flipVertically = function() {
 this.surface.flipVertically();
 }
Surface.prototype.clone = function() {
 var s = new Surface(this.width,this.height,CreateColor(0,0,0));
 s.createFromSurface(this.surface);
 return s;
 }
Surface.prototype.cloneSection = function(x,y,w,h) {
 return this.surface.cloneSection(x,y,w,h);
 }
Surface.prototype.drawText = function(f,x,y,txt) {
 this.surface.drawText(f,x,y,txt);
 }
Surface.prototype.drawZoomedText = function(f,x,y,z,txt) {
 this.surface.drawZoomedText(f,x,y,z,txt);
 }
Surface.prototype.drawTextBox = function(f,x,y,w,h,o,txt) {
 this.surface.drawTextBox(f,x,y,w,h,o,txt);
 }
Surface.prototype.save = function(f) {
 this.surface.save(f);
 }  